#version 430 core
#define M_PI 3.1415926535897932384626433832795

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform float timeOffset;


vec3 displaceVertex() {
	float waveHeight = 0.5 * sin(timeOffset + 10 * position.x);
	vec3 newPos =  position + waveHeight * normal;

	return newPos;
}

float derivativeY() {
	return 0.5 * cos(timeOffset + 10 * position.x);
}

vec3 adjustNormal() {
	vec3 newNormal = vec3(0, 1, derivativeY());

	return newNormal;
}

void main() {
	vert.normal_world = normalMatrix * adjustNormal();
	vert.uv = uv;
	vec4 position_world_ = modelMatrix * vec4(displaceVertex(), 1);
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}